let bit_length n =
  let rec loop a n =
    if n <= 0 then
      a
    else
      loop (a + 1) (n lsr 1) in
  loop 0 (n - 1)

exception Bad_int of int		(* raised only in bits_of_int *)

let bits_of_int size n =		(* convert int to bool list *)
  let rec loop i p a =
    if p >= size then
      List.rev a
    else
      loop (2*i) (p + 1) ((n land i <> 0) :: a) in
  if n < 0 || n >= 1 lsl size then
    raise (Bad_int n)
  else
    loop 1 0 []

let bits2path offset bits =
  let rec loop a offset bits =
    match bits with
      [] -> a
    | bit :: bits ->
	loop ((not bit, offset) :: a) (offset + 1) bits in
  loop [] offset bits

let int2path offset size n =
  bits2path offset (bits_of_int size n)
