open Bdd
open Formulas

type descriptor = {
    clss_size : int;
    perms_size : int;
    types_size : int;
    roles_size : int;
    users_size : int;
    clss_offset : int;
    perms_offset : int;
    in_okay_offset : int;
    in_types_offset : int;
    in_roles_offset : int;
    in_users_offset : int;
    out_okay_offset : int;
    out_types_offset : int;
    out_roles_offset : int;
    out_users_offset : int;
    state_size : int;
    in_state_offset: int;
    out_state_offset: int;
    (* The lookup functions raise Not_found when a mapping for
       a name is not available. *)
    lookup_cls : string -> bdd;
    lookup_perm : string -> bdd;
    lookup_in_okay : bool -> bdd;
    lookup_in_type : string -> bdd;
    lookup_in_role : string -> bdd;
    lookup_in_user : string -> bdd;
    lookup_out_okay : bool -> bdd;
    lookup_out_type : string -> bdd;
    lookup_out_role : string -> bdd;
    lookup_out_user : string -> bdd }

val make_descriptor : string list lts -> descriptor
